'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require('react'));

var _reactDom = _interopRequireDefault(require('react-dom'));

var _propTypes = _interopRequireDefault(require('prop-types'));

var _classnames = _interopRequireDefault(require('classnames'));

require('./index.scss');

var _jsxFileName = 'src/MarqueeX.js';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (_typeof(call) === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + _typeof(superClass)); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * Created by liuduan<liuduan.05.05@163.com>.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * ComponentName MarqueeX
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * Desc 跑马灯显示文字-水平方向
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * GroupName lm-component
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  */


var MarqueeX = function (_Component) {
    _inherits(MarqueeX, _Component);

    function MarqueeX() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, MarqueeX);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MarqueeX.__proto__ || Object.getPrototypeOf(MarqueeX)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            overflowWidth: 0, // 文字超出wrap部分宽度
            animatedWidth: 0 // 文字移动的距离
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    /* ======= 实例属性 ======= */


    _createClass(MarqueeX, [{
        key: 'componentDidMount',
        // 计时器函数

        value: function componentDidMount() {
            this._measureText(this._startAnimation);
            // 监听尺寸变化
            window.addEventListener('resize', this.resetHandle.bind(this));
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if ('children' in nextProps) this.resetHandle();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('resize', this.resetHandle.bind(this));
            if (this._marqueeTimer) this._marqueeTimer = clearTimeout(this._marqueeTimer);
        }

        // 重置动画

    }, {
        key: 'resetHandle',
        value: function resetHandle() {
            var _this2 = this;

            this.setState({
                animatedWidth: 0
            }, function () {
                if (_this2._marqueeTimer) _this2._marqueeTimer = clearTimeout(_this2._marqueeTimer);
                _this2._measureText(_this2._startAnimation);
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var _props = this.props,
                children = _props.children,
                className = _props.className,
                style = _props.style,
                prefixCls = _props.prefixCls,
                type = _props.type,
                speed = _props.speed,
                startDelay = _props.startDelay,
                endDelay = _props.endDelay,
                loop = _props.loop,
                reset = _props.reset,
                others = _objectWithoutProperties(_props, ['children', 'className', 'style', 'prefixCls', 'type', 'speed', 'startDelay', 'endDelay', 'loop', 'reset']);

            var _state = this.state,
                overflowWidth = _state.overflowWidth,
                animatedWidth = _state.animatedWidth;


            var cls = (0, _classnames.default)('lm-marqueeX', prefixCls + '-marqueeX', className);
            var textCls = (0, _classnames.default)(prefixCls + '-marqueeX-text', _defineProperty({}, 'lm-marqueeX-text-' + type, type));

            var wrapStyle = void 0,
                textStyle = {},
                renderChildren = void 0;

            wrapStyle = _extends({
                height: type === 'break' ? 'auto' : 20
            }, style);

            if (type === 'marquee') {
                textStyle = {
                    textAlign: overflowWidth > 0 ? 'left' : 'center',
                    right: animatedWidth
                };
            }

            if (type !== "marquee" && (typeof children === 'undefined' ? 'undefined' : _typeof(children)) === 'object' && children.type) {
                renderChildren = _react.default.cloneElement(children, { className: textCls });
            } else {
                renderChildren = children;
            }

            return _react.default.createElement(
                'div',
                Object.assign({ className: cls, style: wrapStyle }, others, _defineProperty({
                    __source: {
                        fileName: _jsxFileName,
                        lineNumber: 104
                    },
                    __self: this
                }, '__self', this)),
                _react.default.createElement(
                    'div',
                    _defineProperty({ ref: function ref(el) {
                            return _this3.textRef = el;
                        }, className: textCls, style: textStyle, __source: {
                            fileName: _jsxFileName,
                            lineNumber: 105
                        },
                        __self: this
                    }, '__self', this),
                    renderChildren
                )
            );
        }

        /* 私有方法：计算文字超出marquee容器范围的宽度 */

    }, {
        key: '_measureText',
        value: function _measureText(cb) {
            var wrap = _reactDom.default.findDOMNode(this);
            var text = this.textRef;
            if (wrap && text) {
                // 获取marquee容器宽度
                var wrapWidth = wrap.offsetWidth;
                // 获取文字宽度
                var textWidth = text.offsetWidth;
                // 获取文字超出容器部分宽度
                var overflowWidth = textWidth - wrapWidth;
                this.setState({
                    overflowWidth: overflowWidth
                }, cb.bind(this));
            }
        }

        /* 私有方法：计时器-滚动计算 */

    }, {
        key: '_startAnimation',
        value: function _startAnimation() {
            var _this4 = this;

            if (this._marqueeTimer) {
                clearTimeout(this._marqueeTimer);
            }
            var _props2 = this.props,
                type = _props2.type,
                speed = _props2.speed,
                startDelay = _props2.startDelay,
                endDelay = _props2.endDelay,
                loop = _props2.loop;

            var timeout = void 0;
            if (speed) timeout = 1 / speed * 1000;

            var animate = function animate() {
                var _state2 = _this4.state,
                    overflowWidth = _state2.overflowWidth,
                    animatedWidth = _state2.animatedWidth;

                animatedWidth++;
                var isRoundOver = animatedWidth > overflowWidth;
                // 判断单次播放完毕，若播放完毕再判断是否需要循环播放
                if (isRoundOver) {
                    if (loop) {
                        // 开启循环播放函数
                        animatedWidth = 0;
                        _this4._marqueeTimer = setTimeout(function () {
                            _this4.setState({
                                animatedWidth: animatedWidth
                            }, function () {
                                _this4._marqueeTimer = setTimeout(animate, startDelay);
                            });
                        }, endDelay);
                    } else {
                        return;
                    }
                } else {
                    // 播放过程动画函数
                    _this4.setState({
                        animatedWidth: animatedWidth
                    }, function () {
                        if (timeout) {
                            _this4._marqueeTimer = setTimeout(animate, timeout);
                        } else {
                            window.requestAnimationFrame(animate);
                        }
                    });
                }
            };

            // 如果文字内容超出wrap, 开启首次滚动动画
            if (this.state.overflowWidth > 0 && type === 'marquee') {
                this._marqueeTimer = setTimeout(animate, startDelay);
            }
        }
    }]);

    return MarqueeX;
}(_react.Component);

MarqueeX.propTypes = {
    prefixCls: _propTypes.default.string,
    className: _propTypes.default.string,
    type: _propTypes.default.string,
    speed: _propTypes.default.number,
    startDelay: _propTypes.default.number,
    endDelay: _propTypes.default.number,
    loop: _propTypes.default.bool
};
MarqueeX.defaultProps = {
    prefixCls: 'lm',
    className: '',
    /* ===== 计时器相关属性 ===== */
    type: 'marquee', // 显示模式：marquee-跑马灯 | ellipsis-显示... | clip-修剪文本 | break-折行
    speed: 0, // 动画移动距离/每秒
    startDelay: 800, // 动画单次播放开始延时时间
    endDelay: 500, // 动画单次播放结束停留时间
    loop: true // 是否循环播放
};
var _default = MarqueeX;
exports.default = _default;
module.exports = exports['default'];