'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require('react'));

var _propTypes = _interopRequireDefault(require('prop-types'));

var _classnames = _interopRequireDefault(require('classnames'));

require('./index.scss');

var _MarqueeX = _interopRequireDefault(require('./MarqueeX'));

var _MarqueeY = _interopRequireDefault(require('./MarqueeY'));

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsxFileName = 'src/index.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (_typeof(call) === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + _typeof(superClass)); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * Created by liuduan<liuduan.05.05@163.com>.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * ComponentName Toptips
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * Desc 吸顶提示信息条
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * GroupName lm-component
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  */


var Toptips = function (_Component) {
    _inherits(Toptips, _Component);

    function Toptips(props) {
        _classCallCheck(this, Toptips);

        var _this = _possibleConstructorReturn(this, (Toptips.__proto__ || Object.getPrototypeOf(Toptips)).call(this, props));

        _this.state = {
            show: true,
            reset: false
        };

        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }

    _createClass(Toptips, [{
        key: 'onClick',
        value: function onClick() {
            var _props = this.props,
                onClick = _props.onClick,
                mode = _props.mode;
            // 预留钩子

            if (onClick) onClick();
            // 若可关闭的内部实现关闭
            if (mode === 'closable') {
                this.setState({
                    show: !this.state.show
                });
            }
        }
        /* 根据需求渲染后缀 */

    }, {
        key: 'renderSuffix',
        value: function renderSuffix() {
            var _props2 = this.props,
                mode = _props2.mode,
                prefixCls = _props2.prefixCls,
                linkText = _props2.linkText;

            var suffix = null;

            switch (mode) {
                case 'closable':
                    suffix = _react.default.createElement(
                        'div',
                        _defineProperty({ className: prefixCls + '-suffix', onClick: this.onClick, __source: {
                                fileName: _jsxFileName,
                                lineNumber: 74
                            },
                            __self: this
                        }, '__self', this),
                        _react.default.createElement('span', _defineProperty({ className: prefixCls + '-suffix-close', __source: {
                                fileName: _jsxFileName,
                                lineNumber: 75
                            },
                            __self: this
                        }, '__self', this))
                    );
                    break;
                case 'link':
                    suffix = _react.default.createElement(
                        'div',
                        _defineProperty({ className: prefixCls + '-suffix', __source: {
                                fileName: _jsxFileName,
                                lineNumber: 81
                            },
                            __self: this
                        }, '__self', this),
                        _react.default.createElement(
                            'span',
                            _defineProperty({ className: prefixCls + '-suffix-link', __source: {
                                    fileName: _jsxFileName,
                                    lineNumber: 82
                                },
                                __self: this
                            }, '__self', this),
                            linkText
                        )
                    );
                    break;
                default:
                    break;
            }

            return suffix;
        }

        /* 渲染元素 */

    }, {
        key: 'renderTips',
        value: function renderTips() {
            var _this2 = this;

            var _props3 = this.props,
                children = _props3.children,
                prefixCls = _props3.prefixCls,
                marqueePropsX = _props3.marqueePropsX;

            var tiplist = _react.default.Children.toArray(children);
            var showType = {};
            // 若是上下滚动显示则折行处理
            if (tiplist.length > 1) {
                showType['type'] = 'break';
            } else {
                showType = {};
            }
            return tiplist.map(function (item, index) {
                return _react.default.createElement(
                    _MarqueeX.default,
                    Object.assign({}, _extends({}, marqueePropsX, showType), _defineProperty({
                        key: index,
                        prefixCls: prefixCls,
                        reset: _this2.state.reset,
                        __source: {
                            fileName: _jsxFileName,
                            lineNumber: 105
                        },
                        __self: _this2
                    }, '__self', _this2)),
                    item
                );
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props4 = this.props,
                mode = _props4.mode,
                icon = _props4.icon,
                onClick = _props4.onClick,
                children = _props4.children,
                className = _props4.className,
                prefixCls = _props4.prefixCls,
                linkText = _props4.linkText,
                marqueePropsX = _props4.marqueePropsX,
                marqueePropsY = _props4.marqueePropsY,
                others = _objectWithoutProperties(_props4, ['mode', 'icon', 'onClick', 'children', 'className', 'prefixCls', 'linkText', 'marqueePropsX', 'marqueePropsY']);

            var wrapCls = (0, _classnames.default)(prefixCls, className);

            // 处理tip条是否可点击
            var extraProps = {};
            if (mode !== 'closable') extraProps.onClick = onClick;

            return this.state.show ? _react.default.createElement(
                'div',
                Object.assign({ className: wrapCls }, extraProps, others, _defineProperty({
                    __source: {
                        fileName: _jsxFileName,
                        lineNumber: 126
                    },
                    __self: this
                }, '__self', this)),
                icon && _react.default.createElement(
                    'div',
                    _defineProperty({ className: prefixCls + '-icon', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 129
                        },
                        __self: this
                    }, '__self', this),
                    icon
                ),
                _react.default.createElement(
                    _MarqueeY.default,
                    Object.assign({ className: prefixCls + '-main' }, marqueePropsY, _defineProperty({
                        __source: {
                            fileName: _jsxFileName,
                            lineNumber: 132
                        },
                        __self: this
                    }, '__self', this)),
                    this.renderTips()
                ),
                this.renderSuffix()
            ) : null;
        }
    }]);

    return Toptips;
}(_react.Component);

Toptips.propTypes = {
    prefixCls: _propTypes.default.string,
    className: _propTypes.default.string,
    mode: _propTypes.default.string,
    linkText: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]),
    icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]),
    marqueePropsX: _propTypes.default.object,
    marqueePropsY: _propTypes.default.object,
    onClick: _propTypes.default.func
};
Toptips.defaultProps = {
    prefixCls: 'lm-toptips',
    className: '',
    mode: '',
    linkText: '',
    icon: null,
    marqueePropsX: {},
    marqueePropsY: {},
    onClick: function onClick() {}
};
var _default = Toptips;
exports.default = _default;
module.exports = exports['default'];